package com.restlet.client.exception;

import com.restlet.client.async.Deferred.NotLoggedException;

import static com.restlet.client.utils.StringUtils.format;

public class NameAlreadyUsedException extends RuntimeException implements NotLoggedException {

    public static final String TEMPLATE_NAME_ALREADY_USED = "The name %s is already used.";

    public final String name;

    public NameAlreadyUsedException() {
        this(null);
    }

    public NameAlreadyUsedException(String name) {
        super(format(TEMPLATE_NAME_ALREADY_USED, name));
        this.name = name;
    }
}
