package com.restlet.client.gwt_excluded;

import com.restlet.client.function.Executor;
import com.restlet.client.utils.Timer;

import java.util.TimerTask;

public class PureJavaTimer {

    public static Timer getPureJavaTimer() {
        return new Timer() {
            @Override
            public TimerRegistration scheduleOnce(final Executor executor, final int delayInMs) {
                final java.util.Timer delegate = new java.util.Timer();
                delegate.schedule(new TimerTask() {
                    @Override
                    public void run() {
                        executor.execute();
                    }
                }, delayInMs);
                return new TimerRegistrationImpl(delegate);
            }

            @Override
            public TimerRegistration schedule(final Executor executor, final int intervalInMs) {
                final java.util.Timer delegate = new java.util.Timer();
                delegate.scheduleAtFixedRate(new TimerTask() {
                    @Override
                    public void run() {
                        executor.execute();
                    }
                }, 0, intervalInMs);
                return new TimerRegistrationImpl(delegate);
            }

            class TimerRegistrationImpl implements TimerRegistration {
                private final java.util.Timer delegate;

                TimerRegistrationImpl(final java.util.Timer delegate) {
                    this.delegate = delegate;
                }

                @Override
                public void cancel() {
                    delegate.cancel();
                }
            }
        };
    }
}
