package com.restlet.client.html.form.impl;

import com.restlet.client.html.form.FormItemTo;
import com.restlet.client.html.form.FormItemType;
import com.restlet.client.platform.blob.Blob;

import java.io.Serializable;

public class FormItemToImpl implements FormItemTo, Serializable {

    private static final long serialVersionUID = -7710187710627967767L;

    boolean enabled;
    String name;
    String value;
    FormItemType type;
    Blob blobValue;

    @Override
    public boolean isEnabled() {
        return enabled;
    }

    @Override
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String getValue() {
        return value;
    }

    @Override
    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public FormItemType getType() {
        return type;
    }

    @Override
    public void setType(FormItemType type) {
        this.type = type;
    }

    @Override
    public Blob getBlobValue() {
        return blobValue;
    }

    @Override
    public void setBlobValue(Blob blobValue) {
        this.blobValue = blobValue;
    }

    @Override
    public FormItemTo clone() {
        FormItemTo clone = new FormItemToImpl();
        clone.setBlobValue(blobValue);
        clone.setEnabled(enabled);
        clone.setName(name);
        clone.setType(type);
        clone.setValue(value);
        return clone;
    }
}
