package com.restlet.client.model;

import com.restlet.client.function.Predicate;
import com.restlet.client.utils.Sequence;

public enum UpdateType {
    Update, Create, Import, Delete, None;

    public boolean isIn(final UpdateType... types) {
        return Sequence.of(types)
                .some(new Predicate<UpdateType>() {
                    @Override
                    public boolean test(final UpdateType type) {
                        return UpdateType.this == type;
                    }
                });
    }
}
