package com.restlet.client.model.environment.impl;

import com.restlet.client.model.environment.EnvironmentTo;
import com.restlet.client.model.environment.EnvironmentType;
import com.restlet.client.model.environment.EnvironmentVariableTo;
import com.restlet.client.model.impl.EntityToImpl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class EnvironmentToImpl extends EntityToImpl implements EnvironmentTo, Serializable {

    private static final long serialVersionUID = 7317922725907267433L;

    List<EnvironmentVariableTo> variables = new ArrayList<>();

    EnvironmentType contextType;

    @Override
    public List<EnvironmentVariableTo> getVariables() {
        return variables;
    }

    @Override
    public void setVariables(final List<EnvironmentVariableTo> variables) {
        this.variables = variables;
    }

    @Override
    public EnvironmentType getContextType() {
        return contextType;
    }

    @Override
    public void setContextType(final EnvironmentType contextType) {
        this.contextType = contextType;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;

        final EnvironmentToImpl environment = (EnvironmentToImpl) o;

        if (variables != null ? !variables.equals(environment.variables) : environment.variables != null) return false;
        return contextType == environment.contextType;
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 31 * result + (variables != null ? variables.hashCode() : 0);
        result = 31 * result + (contextType != null ? contextType.hashCode() : 0);
        return result;
    }
}
