package com.restlet.client.model.impl;

import com.restlet.client.net.request.RetryConfiguration;

public class RetryConfigurationImpl implements RetryConfiguration {

    private int intervalInSeconds = 0;
    private int retryCount = 1;
    private boolean isEnabled = false;

    @Override
    public int getIntervalInSeconds() {
        return intervalInSeconds;
    }

    @Override
    public void setIntervalInSeconds(final int intervalInSeconds) {
        this.intervalInSeconds = intervalInSeconds;
    }

    @Override
    public int getRetryCount() {
        return retryCount;
    }

    @Override
    public void setRetryCount(final int retryCount) {
        this.retryCount = retryCount;
    }

    @Override
    public boolean isEnabled() {
        return isEnabled;
    }

    @Override
    public void setEnabled(final boolean isEnabled) {
        this.isEnabled = isEnabled;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final RetryConfigurationImpl that = (RetryConfigurationImpl) o;

        if (intervalInSeconds != that.intervalInSeconds) return false;
        if (retryCount != that.retryCount) return false;
        return isEnabled == that.isEnabled;
    }

    @Override
    public int hashCode() {
        int result = intervalInSeconds;
        result = 31 * result + retryCount;
        result = 31 * result + (isEnabled ? 1 : 0);
        return result;
    }
}
