package com.restlet.client.script.runtime;

import java.util.List;

import static com.restlet.client.script.runtime.ScriptMethodParameter.Type.Options;

public class ScriptMethodParameter {

    String name;
    Type type;
    String defaultValue;
    List<String> options;

    public ScriptMethodParameter(String name, List<String> options, String defaultValue) {
        this.type = Options;
        this.name = name;
        this.options = options;
        this.defaultValue = defaultValue;
    }

    public ScriptMethodParameter(String name, List<String> options) {
        this(name, options, null);
    }

    public ScriptMethodParameter(String name, Type type, String defaultValue) {
        this.name = name;
        this.type = type;
        this.defaultValue = defaultValue;
    }

    public ScriptMethodParameter(String name, Type type) {
        this(name, type, null);
    }

    public String getName() {
        return name;
    }

    public Type getType() {
        return type;
    }

    public List<String> getOptions() {
        return options;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public enum Type {
        String, Integer, Options
    }
}
