package com.restlet.client.tests;

import com.restlet.client.model.EntityTo;
import com.restlet.client.tests.impl.ExecutionStateStore.RunStatistics;
import com.restlet.client.tests.impl.ExecutionStateStore.RunType;

import java.util.List;

public interface ContainerTestResult extends TestResult<ContainerTestResult, EntityTo> {

    List<TestResult> getTestResults();

    <T extends TestResult> ContainerTestResult setTestResults(List<T> testResults);

    <T extends TestResult> ContainerTestResult addTestResult(T testResult);

    /**
     * @param fireEvent True to notify listeners that the state has been updated, false otherwise.
     */
    void refreshState(final RunType runType, boolean fireEvent);

    int computeNumberOfDynamicRequests();

    int computeNumberOfLocalRequests();

    void setRunStatistics(RunStatistics runStatistics);

    RunStatistics getRunStatistics();
}
