package com.restlet.client.tests.impl;

import com.restlet.client.model.EntityTo;
import com.restlet.client.net.http.request.HttpRequestTo;
import com.restlet.client.tests.ScenarioTo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import static com.restlet.client.model.EntityTo.Type.Scenario;

public class ScenarioImpl implements ScenarioTo, Serializable {

    private static final long serialVersionUID = 8174163258033984830L;
    private final List<HttpRequestTo> httpRequests = new ArrayList<>();
    private String name;
    private String description;
    private Type type;
    private EntityTo parent;
    private String id;
    private Integer descriptionHeight;
    private String lastModified;
    private List<String> requestOrder = new ArrayList<>();
    private String parentId;
    private boolean isShared;
    private boolean isLocked;
    private boolean isModifiedLocally;
    private String remoteModification;
    private String remoteId;
    private String importedFrom;

    public String getParentId() {
        return parentId;
    }

    public void setParentId(final String parentId) {
        this.parentId = parentId;
    }

    @Override
    public Type getType() {
        return Scenario;
    }

    @Override
    public void setType(final Type type) {
        this.type = type;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(final String name) {
        this.name = name;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public void setDescription(final String description) {
        this.description = description;
    }

    @Override
    public Integer getDescriptionHeight() {
        return descriptionHeight;
    }

    @Override
    public void setDescriptionHeight(final Integer integer) {
        this.descriptionHeight = integer;
    }

    @Override
    public Boolean getDescriptionCollapsed() {
        return null;
    }

    @Override
    public void setDescriptionCollapsed(final Boolean collapsed) {

    }

    @Override
    public String getId() {
        return id;
    }

    @Override
    public void setId(final String id) {
        this.id = id;
    }

    @Override
    public String getLastModified() {
        return lastModified;
    }

    @Override
    public void setLastModified(final String modified) {
        this.lastModified = modified;
    }

    @Override
    public EntityTo getParent() {
        return parent;
    }

    @Override
    public void setParent(final EntityTo parent) {
        this.parent = parent;
    }

    @Override
    public List<String> getRequestOrder() {
        return requestOrder;
    }

    @Override
    public void setRequestOrder(final List<String> string) {
        this.requestOrder = string;
    }

    @Override
    public boolean isShared() {
        return isShared;
    }

    @Override
    public void setShared(final boolean shared) {
        this.isShared = shared;
    }

    @Override
    public boolean isLocked() {
        return isLocked;
    }

    @Override
    public void setLocked(final boolean isLocked) {
        this.isLocked = isLocked;
    }

    @Override
    public String getRemoteModification() {
        return remoteModification;
    }

    @Override
    public void setRemoteModification(final String token) {
        this.remoteModification = token;
    }

    @Override
    public boolean isModifiedLocally() {
        return isModifiedLocally;
    }

    @Override
    public void setModifiedLocally(final boolean modified) {
        this.isModifiedLocally = modified;
    }

    @Override
    public String getImportedFrom() {
        return importedFrom;
    }

    @Override
    public void setImportedFrom(final String importedFrom) {
        this.importedFrom = importedFrom;
    }

    @Override
    public String getRemoteId() {
        return remoteId;
    }

    @Override
    public void setRemoteId(final String remoteId) {
        this.remoteId = remoteId;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final ScenarioImpl that = (ScenarioImpl) o;

        if (isShared != that.isShared) return false;
        if (httpRequests != null ? !httpRequests.equals(that.httpRequests) : that.httpRequests != null) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        if (description != null ? !description.equals(that.description) : that.description != null) return false;
        if (type != that.type) return false;
        if (parent != null ? !parent.equals(that.parent) : that.parent != null) return false;
        if (id != null ? !id.equals(that.id) : that.id != null) return false;
        if (descriptionHeight != null ? !descriptionHeight.equals(that.descriptionHeight) : that.descriptionHeight != null)
            return false;
        if (lastModified != null ? !lastModified.equals(that.lastModified) : that.lastModified != null) return false;
        if (requestOrder != null ? !requestOrder.equals(that.requestOrder) : that.requestOrder != null) return false;
        if (parentId != null ? !parentId.equals(that.parentId) : that.parentId != null) return false;
        return remoteModification != null ? remoteModification.equals(that.remoteModification) : that.remoteModification == null;

    }

    @Override
    public int hashCode() {
        int result = httpRequests != null ? httpRequests.hashCode() : 0;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + (description != null ? description.hashCode() : 0);
        result = 31 * result + (type != null ? type.hashCode() : 0);
        result = 31 * result + (parent != null && parent.getId() != null ? parent.getId().hashCode() : 0);
        result = 31 * result + (id != null ? id.hashCode() : 0);
        result = 31 * result + (descriptionHeight != null ? descriptionHeight.hashCode() : 0);
        result = 31 * result + (lastModified != null ? lastModified.hashCode() : 0);
        result = 31 * result + (requestOrder != null ? requestOrder.hashCode() : 0);
        result = 31 * result + (parentId != null ? parentId.hashCode() : 0);
        result = 31 * result + (isShared ? 1 : 0);
        result = 31 * result + (remoteModification != null ? remoteModification.hashCode() : 0);
        return result;
    }
}
