package com.restlet.client.utils;

import com.restlet.client.function.Function;

import java.util.List;

import static com.restlet.client.utils.StringUtils.firstUpper;

public class EnumUtils {

    public static <E extends Enum<E>> List<String> getEnumNames(E[] values) {
        return Sequence.of(values).map(new Function<E, String>() {
            @Override
            public String apply(E input) {
                return input.name();
            }
        }).toList();
    }

    public static String getMixpanelName(Enum enumValue) {
        return firstUpper(enumValue.name().toLowerCase()).replaceAll("_", " ");
    }
}
