package com.restlet.client.utils;

import com.restlet.client.model.environment.EnvironmentVariableTo;

import java.util.List;

import static com.restlet.client.utils.StringUtils.isBlank;

public class EnvironmentToHelper {

    public static String expandVariables(final List<EnvironmentVariableTo> variables, final String text) {
        if (isBlank(text)) {
            return null;
        }
        return getVariableValue(variables, text);
    }

    private static String getVariableValue(final List<EnvironmentVariableTo> variables, final String varName) {
        if (variables == null || isBlank(varName)) {
            return null;
        }

        for (final EnvironmentVariableTo variable : variables) {
            if ((variable.getEnabled() == null || variable.getEnabled()) && varName.equals(variable.getName())) {
                return variable.getValue();
            }
        }
        return null;
    }

}
