package com.restlet.client.utils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class ListBuilder<T> {
    private final List<T> local = new ArrayList<>();

    private ListBuilder() {
    }

    public static <T> ListBuilder<T> builder() {
        return new ListBuilder<>();
    }

    public ListBuilder<T> add(T value) {
        local.add(value);
        return this;
    }

    public ListBuilder<T> addAll(Collection<? extends T> list) {
        local.addAll(list);
        return this;
    }

    public List<T> build() {
        return local;
    }
}
