package com.restlet.client.utils;

import com.restlet.client.model.EntityTo;
import com.restlet.client.model.EntityTreeNode;
import com.restlet.client.model.UpdateType;
import com.restlet.client.tests.ScenarioTo;

import java.util.ArrayList;

import static com.restlet.client.model.EntityTo.Type.Request;
import static com.restlet.client.model.EntityTo.Type.Scenario;
import static com.restlet.client.model.UpdateType.Create;
import static com.restlet.client.model.UpdateType.None;
import static com.restlet.client.model.UpdateType.Update;
import static com.restlet.client.utils.StringUtils.isBlank;

public class RepositoryUtils {
    // completing the clone tree node up to the root tree node
    public static EntityTreeNode getImportableEntityTreeNodeByCompletingParents(EntityTreeNode entityTreeNode) {
        final EntityTo currentEntity = entityTreeNode.entity;
        EntityTo parent = currentEntity.getParent();

        while (parent != null) {
            UpdateType parentUpdateType = isBlank(parent.getId()) ? Create : None;

            if (currentEntity.getType() == Request && parent.getType() == Scenario) {
                final ScenarioTo scenario = (ScenarioTo) parent;
                if (scenario.getRequestOrder() == null) {
                    scenario.setRequestOrder(new ArrayList<String>());
                }
                if (!scenario.getRequestOrder().contains(currentEntity.getName())) {
                    scenario.getRequestOrder().add(currentEntity.getName());
                    parentUpdateType = isBlank(parent.getId()) ? Create : Update;
                }
            }

            entityTreeNode = new EntityTreeNode(parent, parentUpdateType, entityTreeNode);
            parent = parent.getParent();
        }
        return entityTreeNode;
    }
}
